<template lang="html">
  <div class="wave-ctn">
  <svg version="1.1" xmlns="http://www.w3.org/2000/svg" class="wave" >
    <defs></defs>
    <path :id="this.wave.id" d=""/>
  </svg>
</div>
</template>

<script>
import { TweenMax } from 'gsap'
export default {
  name:'AudioReaderWave',
  props:['height','bones','amplitude','color','speed','_id'],
  data(){
    return{
      lastUpdate:Date.now(),
      totalTime:0,
      gWidth:760,
      gHeight:124,
      wave:{
        id:this._id,
        height: Number(this.height),
        amplitude: Number(this.amplitude),
        speed: Number(this.speed),
        bones: Number(this.bones),
        color: this.color
      }
    }
  },
  mounted(){
    TweenLite.set(document.getElementById(this.wave.id), {attr:{fill: this.wave.color}});
  	setInterval(this.draw.bind(this) , 100)
  },
  methods:{
    updateNow() {
    	this.lastUpdate = Math.round(Date.now() / 1000)
    },
    drawPoints(factor) {
        var points = [];

        for (var i = 0; i <= this.wave.bones; i++) {
            var x = i/this.wave.bones * this.gWidth;
            var sinSeed = (factor + (i + i % this.wave.bones)) * this.wave.speed * 100;
            var sinHeight = Math.sin(sinSeed / 100) * this.wave.amplitude;
            var yPos = Math.sin(sinSeed / 100) * sinHeight  + this.wave.height;
            points.push({x: x, y: yPos});
        }

        return points;
    },
    drawPath(points) {
        var SVGString = 'M ' + points[0].x + ' ' + points[0].y;

        var cp0 = {
            x: (points[1].x - points[0].x) / 2,
            y: (points[1].y - points[0].y) + points[0].y + (points[1].y - points[0].y)
        };

        SVGString += ' C ' + cp0.x + ' ' + cp0.y + ' ' + cp0.x + ' ' + cp0.y + ' ' + points[1].x + ' ' + points[1].y;

        var prevCp = cp0;
        var inverted = -1;

        for (var i = 1; i < points.length-1; i++) {
            var cpLength = Math.sqrt(prevCp.x * prevCp.x + prevCp.y * prevCp.y);
            var cp1 = {
                x: (points[i].x - prevCp.x) + points[i].x,
                y: (points[i].y - prevCp.y) + points[i].y
            };

            SVGString += ' C ' + cp1.x + ' ' + cp1.y + ' ' + cp1.x + ' ' + cp1.y + ' ' + points[i+1].x + ' ' + points[i+1].y;
            prevCp = cp1;
            inverted = -inverted;
        }

        SVGString += ' L ' + this.gWidth + ' ' + this.gHeight;
        SVGString += ' L 0 ' + this.gHeight + ' Z';
        return SVGString;
    },
    draw(){
      var now = window.Date.now();
      if (this.lastUpdate) {
          var elapsed = (now-this.lastUpdate) / 1000;
          this.lastUpdate = now;

          this.totalTime += elapsed;


          var factor = this.totalTime*Math.PI;
          TweenMax.to(document.getElementById(this.wave.id), this.wave.speed, {
              attr:{
                  d: this.drawPath(this.drawPoints(factor))
              },
              ease: Power1.easeInOut
          });

      } else {
          this.lastUpdate = now;
      }

      function draw() {
            requestAnimationFrame(draw);
        }

        return draw();
    }

  },
  watch:{
  }
}
</script>

<style lang="css">
.wave-ctn{
  z-index: 2;
  width: 760px;
  height: 124px;
    position: absolute;
    display: flex;
  left:0;
  top:0;
}
.wave {
  width: 100%;
  height: 100%;


}
</style>
